#ifndef FMINST_HPP
#define FMINST_HPP

struct OP {
	int MUL, TL, KS, AR, D1R, D2R, D1L, RR, DT1, DT2, AME;
	OP() {
		MUL = 1;
		TL = 127;
		KS = 0;
		AR = 31;
		D1R = 0;
		D2R = 0;
		D1L = 0;
		RR = 15;
		DT1 = 0;
		DT2 = 0;
		AME = 0;
	}
};
struct FMINST {
	OP op[4];
	int RL, FB, CON, SLOT, NE, KC, KF, PMS, AMS;
	int SPD, AMD, PMD, WF, NFRQ;
	FMINST() {
		RL = 64;
		FB = 0;
		CON = 7;
		SLOT = 0;
		NE = 0;
		KC = 0;
		KF = 0;
		PMS = 0;
		AMS = 0;

		SPD = 0;
		AMD = 0;
		PMD = 0;
		WF = 0;
		NFRQ = 0;
	}
};

enum {
	ERR_NOERR  = 0x00000000,
	ERR_NOFILE = 0x10000000,
	ERR_SYNTAX = 0x20000000,
	ERR_LESPRM = 0x30000000,
};

class FMInst
{
private:
	static const unsigned int FM_PROGRAM_MAX = 128;

public:
	int Load(char *);
	unsigned int GetMaxInst(void);

	FMINST fminst[FM_PROGRAM_MAX];
};

#endif
