#ifndef OPN2DRV_HPP
#define OPN2DRV_HPP

#include <vector>
#include "fminst.hpp"
#include "vgmout.hpp"

class OPN2DRV {
	static const unsigned int OPN2_CLOCK  = 7670453;
	static const unsigned int FM_CHANNEL_MAX = 6;

	enum {
		VOL_MAX = 127,
		PROG_MAX = 127,
	};
//	std::vector<FM::OPM*> opm;

	struct : FMINST {
		bool key_on;
		unsigned char program;
		unsigned char pan;
		unsigned char velocity;
		unsigned char volume;
		unsigned char note;
		unsigned char note_prev;
		int detune;
		int porta_time;
		int porta_detune;
		int porta_frame;
		int porta_delta;
	} Channel[FM_CHANNEL_MAX];

	FMInst *pFminst;
	VGMOUT *pVgmOut;

	void SetTL(unsigned int ch, unsigned int op, unsigned int vol);

public:
	OPN2DRV();
	void VgmSet(VGMOUT *p);
	void InstSet(FMInst* fminst);
	void KeyOn(unsigned int ch);
	void KeyOff(unsigned int ch);
	void SetNote(unsigned int ch, unsigned int note);
	void SetDetune(unsigned int ch, int detune);
	void SetVolume(unsigned int ch, unsigned int vol);
	void SetPan(unsigned int ch, unsigned int pan);
	void SetProgram(unsigned int ch, unsigned int program);
	void SetPortamentTime(unsigned int ch, unsigned int porta_time);

	void SetTimerA(unsigned short na);
	void SetTimerB(unsigned char clkb);
	void SetTimerA_ByTempo(unsigned short tempo, unsigned short tpqm);
	void SetTimerB_ByTempo(unsigned short tempo, unsigned short tpqm);
	void SetTimerB_ByMilliSeconds(unsigned short ms);

	void RunFrame(void);

	void SetReg(unsigned int bank, unsigned int reg, unsigned int value);
};

#endif
